// Emacs style mode select   -*- C++ -*- 
//-----------------------------------------------------------------------------
//
// $Id: d_englsh.h,v 1.2 2000-08-12 21:29:25 fraggle Exp $
//
// Copyright (C) 1993-1996 by id Software, Inc.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// DESCRIPTION:
//  Printed strings for translation.
//  English language support (default).
//  See dstrings.h for suggestions about foreign language BEX support
//
//-----------------------------------------------------------------------------

#ifndef __D_ENGLSH__
#define __D_ENGLSH__

//
//  Printed strings for translation
//

//
// D_Main.C
//
#define D_DEVSTR    "Development mode ON.\n"
#define D_CDROM     "CD-ROM Version: default.cfg from c:\\doomdata\n"

//
//  M_Menu.C
//
#define PRESSKEY    "press a key."
#define PRESSYN     "press y or n."
#define QUITMSG     "are you sure you want to\nquit this great game?"
#define LOADNET     "you can't do load while in a net game!\n\n"PRESSKEY
#define QLOADNET    "you can't quickload during a netgame!\n\n"PRESSKEY
#define QSAVESPOT   "you haven't picked a quicksave slot yet!\n\n"PRESSKEY
#define SAVEDEAD    "you can't save if you aren't playing!\n\n"PRESSKEY
#define QSPROMPT    "quicksave over your game named\n\n'%s'?\n\n"PRESSYN
#define QLPROMPT    "do you want to quickload the game named\n\n'%s'?\n\n"PRESSYN

#define NEWGAME \
  "you can't start a new game\n"\
  "while in a network game.\n\n"PRESSKEY

// 2023/12/05 slightly modified text from Freedoom 0.8
#define NIGHTMARE \
  "this is the highest skill level.\n"\
  "do not try unless you're experienced.\n\n"\
  "(press y to confirm)"

#define SWSTRING  \
  "this is the shareware version of doom.\n\n"\
  "you need to order the entire trilogy.\n\n"PRESSKEY

#define MSGOFF      "Messages OFF"
#define MSGON       "Messages ON"
#define NETEND      "you can't end a netgame!\n\n"PRESSKEY
#define ENDGAME     "are you sure you want to end the game?\n\n"PRESSYN

#define DOSY        "(press y to quit)"

#define DETAILHI    "High detail"
#define DETAILLO    "Low detail"
#define GAMMALVL0   "Gamma correction OFF"
#define GAMMALVL1   "Gamma correction level 1"
#define GAMMALVL2   "Gamma correction level 2"
#define GAMMALVL3   "Gamma correction level 3"
#define GAMMALVL4   "Gamma correction level 4"
#define EMPTYSTRING "empty slot"

// 2023/12/03 Harmony messages from the DEHACKED lump

//
//  P_inter.C
// 
#define GOTARMOR    "Armor"
#define GOTMEGA     "Marine Armor"
#define GOTHTHBONUS "Health bonus"
#define GOTARMBONUS "Armor patch"
#define GOTSTIM     "Healing mushroom"
#define GOTMEDINEED "You needed that!"
#define GOTMEDIKIT  "Medical kit"
#define GOTSUPER    "Super health"

#define GOTBLUECARD "Green keycard"
#define GOTYELWCARD "Yellow keycard"
#define GOTREDCARD  "Purple keycard"
#define GOTBLUESKUL "Green key"
#define GOTYELWSKUL "Yellow key"
#define GOTREDSKULL "Purple key"

#define GOTINVUL    "Invulnerability!"
#define GOTBERSERK  "RAGE!"
#define GOTINVIS    "Cloak"
#define GOTSUIT     "Anti-radiation"
#define GOTMAP      "A map"

#define GOTVISOR    "Light"

#define GOTMSPHERE  "Mega Powerup" // unused?

#define GOTCLIP     "Bullets"
#define GOTCLIPBOX  "Bullets"
#define GOTROCKET   "Gem grenade"
#define GOTROCKBOX  "Gem grenades"
#define GOTCELL     "Chaos bar"
#define GOTCELLBOX  "Chaos bars"
#define GOTSHELLS   "4 Shotgun shells"
#define GOTSHELLBOX "Shotgun shells"

#define GOTBACKPACK "Ammo backpack"

#define GOTBFG9000  "Cluster crystal!"
#define GOTCHAINGUN "Minigun"
#define GOTCHAINSAW "Circular saw" // unused?
#define GOTLAUNCHER "Grenade launcher"
#define GOTPLASMA   "Entropy thrower"
#define GOTSHOTGUN  "Shotgun"
#define GOTSHOTGUN2 "Double-barrel Shotgun" // unused?

//
// P_Doors.C
//
#define PD_BLUEO    "You need a green key"
#define PD_REDO     "You need a purple key"
#define PD_YELLOWO  "You need a yellow key"
#define PD_BLUEK    "You need a green key"
#define PD_REDK     "You need a purple key"
#define PD_YELLOWK  "You need a yellow key"
//jff 02/05/98 Create messages specific to card and skull keys
#define PD_BLUEC    "You need a green keycard"
#define PD_REDC     "You need a purple keycard"
#define PD_YELLOWC  "You need a yellow keycard"
#define PD_BLUES    "You need a green key"
#define PD_REDS     "You need a purple key"
#define PD_YELLOWS  "You need a yellow key"
#define PD_ANY      "You need a key"
#define PD_ALL3     "You need all three keys"
#define PD_ALL6     "You need all six keys and keycards"

//
//  G_game.C
//
#define GGSAVED     "game saved."

//
//  HU_stuff.C
//
#define HUSTR_MSGU  "[Message unsent]"
// 2023/12/03 Ultimate Doom map names -- unused
#define HUSTR_E1M1  "E1M1"
#define HUSTR_E1M2  "E1M2"
#define HUSTR_E1M3  "E1M3"
#define HUSTR_E1M4  "E1M4"
#define HUSTR_E1M5  "E1M5"
#define HUSTR_E1M6  "E1M6"
#define HUSTR_E1M7  "E1M7"
#define HUSTR_E1M8  "E1M8"
#define HUSTR_E1M9  "E1M9"

#define HUSTR_E2M1  "E2M1"
#define HUSTR_E2M2  "E2M2"
#define HUSTR_E2M3  "E2M3"
#define HUSTR_E2M4  "E2M4"
#define HUSTR_E2M5  "E2M5"
#define HUSTR_E2M6  "E2M6"
#define HUSTR_E2M7  "E2M7"
#define HUSTR_E2M8  "E2M8"
#define HUSTR_E2M9  "E2M9"

#define HUSTR_E3M1  "E3M1"
#define HUSTR_E3M2  "E3M2"
#define HUSTR_E3M3  "E3M3"
#define HUSTR_E3M4  "E3M4"
#define HUSTR_E3M5  "E3M5"
#define HUSTR_E3M6  "E3M6"
#define HUSTR_E3M7  "E3M7"
#define HUSTR_E3M8  "E3M8"
#define HUSTR_E3M9  "E3M9"

#define HUSTR_E4M1  "E4M1"
#define HUSTR_E4M2  "E4M2"
#define HUSTR_E4M3  "E4M3"
#define HUSTR_E4M4  "E4M4"
#define HUSTR_E4M5  "E4M5"
#define HUSTR_E4M6  "E4M6"
#define HUSTR_E4M7  "E4M7"
#define HUSTR_E4M8  "E4M8"
#define HUSTR_E4M9  "E4M9"
// 2023/12/03 Harmony level names
#define HUSTR_1     "map01: abduction"
#define HUSTR_2     "map02: harm's way"
#define HUSTR_3     "map03: mount sacrifice"
#define HUSTR_4     "map04: megalopolis"
#define HUSTR_5     "map05: the hospital"
#define HUSTR_6     "map06: weapons factory"
#define HUSTR_7     "map07: underwater lab"
#define HUSTR_8     "map08: airstrip one"
#define HUSTR_9     "map09: launch base"
#define HUSTR_10    "map10: the radioactive zone"
#define HUSTR_11    "map11: echidna"
  
#define HUSTR_12    "map12: mutopia"
#define HUSTR_13    "map13: the omega"
#define HUSTR_14    "map14: -credits-"
#define HUSTR_15    "map15: bonus- rematch"
#define HUSTR_16    "map16: empty map"
#define HUSTR_17    "map17: empty map"
#define HUSTR_18    "map18: empty map"
#define HUSTR_19    "map19: empty map"
#define HUSTR_20    "map20: empty map"
  
#define HUSTR_21    "map21: empty map"
#define HUSTR_22    "map22: empty map"
#define HUSTR_23    "map23: empty map"
#define HUSTR_24    "map24: empty map"
#define HUSTR_25    "map25: empty map"
#define HUSTR_26    "map26: empty map"
#define HUSTR_27    "map27: empty map"
#define HUSTR_28    "map28: empty map"
#define HUSTR_29    "map29: empty map"
#define HUSTR_30    "map30: empty map"
  
#define HUSTR_31    "map31: -credits-"
#define HUSTR_32    "map32: empty map"

#define PHUSTR_1     "map01"
#define PHUSTR_2     "map02"
#define PHUSTR_3     "map03"
#define PHUSTR_4     "map04"
#define PHUSTR_5     "map05"
#define PHUSTR_6     "map06"
#define PHUSTR_7     "map07"
#define PHUSTR_8     "map08"
#define PHUSTR_9     "map09"
#define PHUSTR_10    "map10"
#define PHUSTR_11    "map11"
  
#define PHUSTR_12    "map12"
#define PHUSTR_13    "map13"
#define PHUSTR_14    "map14"
#define PHUSTR_15    "map15"
#define PHUSTR_16    "map16"
#define PHUSTR_17    "map17"
#define PHUSTR_18    "map18"
#define PHUSTR_19    "map19"
#define PHUSTR_20    "map20"
  
#define PHUSTR_21    "map21"
#define PHUSTR_22    "map22"
#define PHUSTR_23    "map23"
#define PHUSTR_24    "map24"
#define PHUSTR_25    "map25"
#define PHUSTR_26    "map26"
#define PHUSTR_27    "map27"
#define PHUSTR_28    "map28"
#define PHUSTR_29    "map29"
#define PHUSTR_30    "map30"
  
#define PHUSTR_31    "map31"
#define PHUSTR_32    "map32"

#define THUSTR_1     "map01"
#define THUSTR_2     "map02"
#define THUSTR_3     "map03"
#define THUSTR_4     "map04"
#define THUSTR_5     "map05"
#define THUSTR_6     "map06"
#define THUSTR_7     "map07"
#define THUSTR_8     "map08"
#define THUSTR_9     "map09"
#define THUSTR_10    "map10"
#define THUSTR_11    "map11"
  
#define THUSTR_12    "map12"
#define THUSTR_13    "map13"
#define THUSTR_14    "map14"
#define THUSTR_15    "map15"
#define THUSTR_16    "map16"
#define THUSTR_17    "map17"
#define THUSTR_18    "map18"
#define THUSTR_19    "map19"
#define THUSTR_20    "map20"
  
#define THUSTR_21    "map21"
#define THUSTR_22    "map22"
#define THUSTR_23    "map23"
#define THUSTR_24    "map24"
#define THUSTR_25    "map25"
#define THUSTR_26    "map26"
#define THUSTR_27    "map27"
#define THUSTR_28    "map28"
#define THUSTR_29    "map29"
#define THUSTR_30    "map30"
  
#define THUSTR_31    "map31"
#define THUSTR_32    "map32"

#define HUSTR_CHATMACRO1  "I'm ready to kick butt!"
#define HUSTR_CHATMACRO2  "I'm OK."
#define HUSTR_CHATMACRO3  "I'm not looking too good!"
#define HUSTR_CHATMACRO4  "Help!"
#define HUSTR_CHATMACRO5  "You suck!"
#define HUSTR_CHATMACRO6  "Next time, scumbag..."
#define HUSTR_CHATMACRO7  "Come here!"
#define HUSTR_CHATMACRO8  "I'll take care of it."
#define HUSTR_CHATMACRO9  "Yes"
#define HUSTR_CHATMACRO0  "No"

#define HUSTR_TALKTOSELF1 "You mumble to yourself"
#define HUSTR_TALKTOSELF2 "Who's there?"
#define HUSTR_TALKTOSELF3 "You scare yourself"
#define HUSTR_TALKTOSELF4 "You start to rave"
#define HUSTR_TALKTOSELF5 "You've lost it..."

#define HUSTR_MESSAGESENT "[Message Sent]"

// The following should NOT be changed unless it seems
// just AWFULLY necessary

#define HUSTR_PLRGREEN    "Purpl: "
#define HUSTR_PLRINDIGO   "Green: "
#define HUSTR_PLRBROWN    "Orang: "
#define HUSTR_PLRRED      "Red: "

#define HUSTR_KEYGREEN    'p'
#define HUSTR_KEYINDIGO   'g'
#define HUSTR_KEYBROWN    'o'
#define HUSTR_KEYRED      'r'

//
//  AM_map.C
//

// 2023/12/05 taken from Freedoom
#define AMSTR_FOLLOWON    "map following player"
#define AMSTR_FOLLOWOFF   "map no longer following player"

#define AMSTR_GRIDON      "map grid on"
#define AMSTR_GRIDOFF     "map grid off"

#define AMSTR_MARKEDSPOT  "added map bookmark"
#define AMSTR_MARKSCLEARED  "all map bookmarks cleared"

//
//  ST_stuff.C
//

#define STSTR_MUS       "music changed"
#define STSTR_NOMUS     "IMPOSSIBLE SELECTION"
#define STSTR_DQDON     "invincible!"
#define STSTR_DQDOFF    "back to normal"

#define STSTR_KFAADDED  "fully decked out"
#define STSTR_FAADDED   "all weapons and ammo"

#define STSTR_NCON      "walk through walls!"
#define STSTR_NCOFF     "you're tangible again"

#define STSTR_BEHOLD    "unused cheat menu"
#define STSTR_BEHOLDX   "Power-up Toggled"

#define STSTR_CHOPPERS  "vroom!"
#define STSTR_CLEV      "Changing Level..."

#define STSTR_COMPON    "Compatibility Mode On"            // phares
#define STSTR_COMPOFF   "Compatibility Mode Off"           // phares

//
//  F_Finale.C
//
#define E1TEXT \
  "unused text" 
  
  
#define E2TEXT \
  "unused text"
  
  
#define E3TEXT \
  "unused text"
  
  
#define E4TEXT \
  "unused text"
  
  
// 2023/12/03 Harmony intermission screens  
// after level 6, put this:
  
#define C1TEXT \
  "YOUR LEADER AND FRIEND AMIRA WAS ABDUCTED.\n" \
  "THE MUTANTS OF THE PAX POX HAVE TAKEN HER\n" \
  "BUT YOU DON'T KNOW WHERE TO.\n" \
  "\n"\
  "THIS WEAPONS FACTORY PRODUCED MANY OF THE\n" \
  "WEAPONS THAT HELPED CREATE THE MUTANTS.\n" \
  "IT MAKES SENSE YOU WILL BE ABLE TO FIND MORE\n" \
  "INFORMATION HERE AND HOPEFULLY A WAY TO\n" \
  "END THE PAX POX ONCE AND FOR ALL...\n" \
  "\n"\
  "HERE WE GO!"
  
  
// After level 11, put this:
  
#define C2TEXT \
  "YOU FEEL SICK IN YOU STOMACH...\n" \
  "LOOKING IN THE FACE OF THE MUTANT QUEEN...\n"\
  "THAT THING... THAT USED TO BE...\n"\
  "YOUR FRIEND... AMIRA!\n"\
  "\n"\
  "THOSE MONSTERS MUST HAVE FOUND A WAY TO\n"\
  "MUTATE HER AND TURN HER INTO THIS\n"\
  "HIDIOUS CREATURE TO BEAR THEIR OFFSPRING.\n"\
  "\n"\
  "-sigh-\n"\
  "YOU GET YOURSELF TOGETHER.\n"\
  "THEY ARE GOING TO PAY FOR MAKING YOU KILL\n"\
  "YOUR FRIEND!\n"\
  "\n"\
  "HELL HATH NO FURY LIKE A WOMAN SCORNED!"
  
  
// After level 20, put this:
  
#define C3TEXT \
  "unused text"
  
  
// After level 29, put this:
  
#define C4TEXT \
  "unused text"
  
    
// Before level 31, put this:
  
  #define C5TEXT \
  "YOUR JOURNEY ENDS WHERE IT BEGAN,\n"\
  "\n"\
  "NOW THAT IT IS OVER, YOU WONDER:\n"\
  "HOW MANY MONSTERS ARE STILL OUT THERE?\n"\
  "AND HOW MANY HUMAN SURVIVORS?"
  
  
// Before level 32, put this:
  
  #define C6TEXT \
  "unused text"


// after map 06 
  
  #define P1TEXT  \
  "unused text"  
  
  
// after map 11
  
  #define P2TEXT \
  "unused text"
  
  
// after map 20
  
  #define P3TEXT \
  "unused text"
  
  
// after map 30
  
  #define P4TEXT \
  "unused text"
  
  
// before map 31
  
#define P5TEXT \
  "unused text"
  
  
// before map 32
  
#define P6TEXT \
  "unused text"
  
  
#define T1TEXT \
  "unused text"
  
#define T2TEXT \
  "unused text"
  
#define T3TEXT \
  "unused text"
  
#define T4TEXT \
  "unused text"
  
  
#define T5TEXT \
  "unused text"
  
#define T6TEXT \
  "unused text"



//
// Character cast strings F_FINALE.C
//
#define CC_ZOMBIE "THE ECHIDNA"
#define CC_SHOTGUN  "FOLLOWER"
#define CC_HEAVY  "MUTANT SOLDIER"
#define CC_IMP  "BAM"
#define CC_DEMON  "BEASTL."
#define CC_LOST "MINE"
#define CC_CACO "AEROSOL"
#define CC_HELL "UNUSED"
#define CC_BARON  "CRITTER"
#define CC_ARACH  "PHAGE"
#define CC_PAIN "MINE"
#define CC_REVEN  "PREDATOR"
#define CC_MANCU  "DEBRIS"
#define CC_ARCH "FALLEN F."
#define CC_SPIDER "THE ECHIDNA"
#define CC_CYBER  "CENTAUR"
#define CC_HERO "HARMONY"


#endif

//----------------------------------------------------------------------------
//
// $Log: d_englsh.h,v $
// Revision 1.2  2000-08-12 21:29:25  fraggle
// change license header
//
// Revision 1.1.1.1  2000/07/29 13:20:41  fraggle
// imported sources
//
// Revision 1.5  1998/05/04  21:33:57  thldrmn
// commenting and reformatting
//
// Revision 1.4  1998/02/08  15:26:40  jim
// New messages for keyed doors
//
// Revision 1.3  1998/01/28  12:23:02  phares
// TNTCOMP cheat code added
//
// Revision 1.2  1998/01/26  19:26:21  phares
// First rev with no ^Ms
//
// Revision 1.1.1.1  1998/01/19  14:02:51  rand
// Lee's Jan 19 sources
//
//
//----------------------------------------------------------------------------
